package cn.rankin.cmsweb.controller.resource;

import cn.rankin.cmsweb.service.resource.ResourceService;
import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.common.utils.dto.resource.ResourceSearchDTO;
import cn.rankin.common.utils.dto.resource.ResourceDTO;
import cn.rankin.common.utils.util.BeanUtil;
import cn.rankin.common.utils.vo.resource.ResourceVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping(value = "/resource")
public class ResourceController {

    @Autowired
    private ResourceService resourceService;

    @RequestMapping(value = "/list")
    public APIResult<Page<ResourceVo>> search(ResourceSearchDTO resourceSearchDTO) {
        return resourceService.search(BeanUtil.convertToMap(resourceSearchDTO));
    }

    @RequestMapping(method = RequestMethod.POST)
    public APIResult<ResourceVo> create(@RequestBody ResourceDTO resourceDTO) {
        return resourceService.create(resourceDTO);
    }
}
