package cn.rankin.cmsweb.service.product;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.product.dto.WareDTO;
import cn.rankin.data.api.product.vo.WareVo;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

@FeignClient(value = "${service.product.name}")
public interface WareService {

    @RequestMapping(value = "/ware/list", method = RequestMethod.GET)
    APIResult<Page<WareVo>> search(@RequestParam Map<String, Object> searchDTO);

    @RequestMapping(value = "/ware", method = RequestMethod.POST)
    APIResult<WareVo> create(@RequestBody WareDTO wareDTO);

    @RequestMapping(value = "/ware", method = RequestMethod.PUT)
    APIResult<WareVo> update(@RequestBody WareDTO wareDTO);

    @RequestMapping(value = "/ware/{id}", method = RequestMethod.DELETE)
    APIResult delete(@PathVariable("id") String id);

    @RequestMapping(value = "/ware/{id}", method = RequestMethod.GET)
    APIResult<WareVo> getWare(@PathVariable("id") String id);
}
