package cn.rankin.productservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.product.entity.Goods;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface GoodsRepository extends BasicJpaRepository<Goods, String> {

    @Query(value = "select g from Goods g where g.pid in (?1) and g.merchantId in (?2) and g.status = 0")
    List<Goods> findByPidsAndMerchantIds(List<String> pids, List<String> merchantIds);

    @Query(value = "select g from Goods g where g.pid = ?1 and g.merchantId = ?2 and g.status = 0 order by g.sort")
    List<Goods> findByPidAndMerchantId(String pid, String merchantId);

    @Query(value = "select g from Goods g where g.id in (?1) and g.status = ?2")
    List<Goods> findByIds(List<String> goodIds, BaseStatusEnum status);

    @Modifying(clearAutomatically = true)
    @Query(value = "update Goods g set g.status = 1 where g.id = ?1")
    Integer deleteById(String id);
}
