package cn.rankin.productservice.repository;

import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.product.entity.PackageProductRelation;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface PackageProductRelationRepository extends BasicJpaRepository<PackageProductRelation, String> {

    @Query(value = "select r from PackageProductRelation r where r.packageId = ?1 and r.status = 0 order by r.sort")
    List<PackageProductRelation> findByPackageId(String packageId);

    @Modifying(clearAutomatically = true)
    @Query(value = "update PackageProductRelation r set r.status = 1 where r.packageId = ?1")
    Integer deleteByPackageId(String pkgId);
}
