package cn.rankin.productservice.repository;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.common.utils.jpa.BasicJpaRepository;
import cn.rankin.data.api.product.entity.Tag;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface TagRepository extends BasicJpaRepository<Tag, String> {

    List<Tag> findByGroupId(String groupId);

    @Query(value = "select t from Tag t where t.id in (?1) and t.status = ?2")
    List<Tag> findByIds(List<String> tagIdList, BaseStatusEnum status);

    @Modifying(clearAutomatically = true)
    @Query(value = "update Tag t set t.status = 1 where t.id = ?1")
    Integer deleteById(String tagId);
}
