package cn.rankin.task.task.order;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.enums.ProductTypeEnum;
import cn.rankin.data.api.trade.entity.OrderGoods;
import cn.rankin.data.api.trade.entity.OrderProductSnapshot;
import cn.rankin.data.api.trade.entity.Order;
import cn.rankin.data.api.user.vo.CampusVo;
import cn.rankin.data.api.user.vo.TerminalUserVo;
import cn.rankin.task.service.UserService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@Slf4j
@Component
public class OrderCompleteTask {

    public final static long ONE_MINUTE = 10 * 1000;

    public final static Integer SIZE = 100;

    @Autowired
    private UserService userService;


    public List<OrderProductSnapshot> toSnaptshots(Order order, TerminalUserVo terminalUserVo, CampusVo campusVo) {
        List<OrderProductSnapshot> snapshotList = new ArrayList<>();
        String orderId = order.getId();
        String userId = order.getUid();
        String userName = terminalUserVo.getName();
        String userCode = terminalUserVo.getCode();
        String campusId = campusVo.getId();
        String campusCode = campusVo.getCode();
        String campusName = campusVo.getName();

        List<String> goodsIdList = new ArrayList<>();
        List<String> productIdList = new ArrayList<>();
        List<OrderGoods> orderGoodsList = order.getGoods();

        for (OrderGoods orderGoods : orderGoodsList) {
            ProductTypeEnum type = orderGoods.getType();
            String goodsId = orderGoods.getGoodsId();
            String productId = orderGoods.getPid();
            if (!goodsIdList.contains(goodsId)) {
                goodsIdList.add(goodsId);
            }
            if(!productIdList.contains(productId)) {
                productIdList.add(productId);
            }
            if (type.equals(ProductTypeEnum.PACKAGE)) {
            }
        }
        return null;

    }

    public List<TerminalUserVo> loadUser(List<String> userIdList) {
        APIResult<List<TerminalUserVo>> apiResult = userService.findUserByIds(userIdList);
        if (!apiResult.getSuccess()) {
            log.error("load user error, {}", apiResult.getMessage());
            return null;
        }

        List<TerminalUserVo> terminalUserVoList = apiResult.getData();
        return terminalUserVoList;
    }

    public Map<String, CampusVo> loadCampus(List<String> campusIdList) {
        APIResult<Map<String, CampusVo>> apiResult = userService.findCampusByIds(campusIdList);
        if (!apiResult.getSuccess()) {
            log.error("load campus error, {}", apiResult.getMessage());
            return null;
        }
        return apiResult.getData();
    }

}

