package cn.rankin.tradeservice.controller;

import cn.rankin.common.utils.api.model.APIResult;
import cn.rankin.common.utils.api.page.Page;
import cn.rankin.data.api.trade.dto.OrderSearchDTO;
import cn.rankin.data.api.trade.dto.UserOrderDTO;
import cn.rankin.data.api.trade.entity.Order;
import cn.rankin.tradeservice.service.OrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping(value = "/order")
public class OrderController {

    @Autowired
    private OrderService orderService;

    // cms web需要做前置校验
    @RequestMapping(method = RequestMethod.POST)
    public APIResult<Order> create(@RequestBody UserOrderDTO userOrderDTO) {
        return orderService.create(userOrderDTO);
    }

    @RequestMapping(value = "/{orderId}", method = RequestMethod.GET)
    public APIResult<Order> getOrder(@PathVariable String orderId) {
        return orderService.getOrder(orderId);
    }

    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public APIResult<Page<Order>> search(OrderSearchDTO searchDTO) {
        return orderService.search(searchDTO);
    }

    @RequestMapping(value = "/pay/{orderId}", method = RequestMethod.POST)
    public APIResult<Boolean> pay(@PathVariable("orderId") String orderId) {
        return orderService.ok(orderId);
    }

    @RequestMapping(value = "/pay/{orderId}", method = RequestMethod.DELETE)
    public APIResult<Boolean> cancel(@PathVariable("orderId") String orderId) {
        return orderService.cancel(orderId);
    }

}
